﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Windows.Forms;

namespace SerialSignals
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            initSerialPort();
        }
        private System.IO.Ports.SerialPort theSerialPortA = new SerialPort();
        private System.IO.Ports.SerialPort theSerialPortB = new SerialPort();
        private void initSerialPort()
        {
            try
            {
                foreach (string s in SerialPort.GetPortNames())
                {
                    cbSerialPortA.Items.Add(s);
                    cbSerialPortB.Items.Add(s);
                }
                cbSerialPortA.SelectedIndex = 0;
                cbSerialPortB.SelectedIndex = 0;
                cbDataBitsA.SelectedIndex = 1;
                cbDataBitsB.SelectedIndex = 1;
                cbParityA.SelectedIndex = 2;
                cbParityB.SelectedIndex = 2;
                cbBaudA.SelectedIndex = 7;
                cbBaudB.SelectedIndex = 7;
                cbStopA.SelectedIndex = 1;
                cbStopB.SelectedIndex = 1;
            }
            catch (Exception)
            {
                MessageBox.Show("Kein serieller Port verfügbar", "Sorry no Bonus, insert coin to continue the game");
                Environment.Exit(1);
            }
        }

        

        private void bOpenPortA_Click(object sender, EventArgs e)
        {
            try
            {

                theSerialPortA.PortName = cbSerialPortA.Items[cbSerialPortA.SelectedIndex].ToString();
                theSerialPortA.BaudRate = Convert.ToInt32((cbBaudA.Items[cbBaudA.SelectedIndex]).ToString());
                string text = cbParityA.Items[cbParityA.SelectedIndex].ToString();
                if (text == "Even")
                    theSerialPortA.Parity = Parity.Even;
                else if (text == "Mark")
                    theSerialPortA.Parity = Parity.Mark;
                else if (text == "None")
                    theSerialPortA.Parity = Parity.None;
                else if (text == "Odd")
                    theSerialPortA.Parity = Parity.Odd;
                else if (text == "Space")
                    theSerialPortA.Parity = Parity.Space;

                text = cbStopA.Items[cbStopA.SelectedIndex].ToString();
                if (text == "0")
                    theSerialPortA.StopBits = StopBits.None;
                else if (text == "1")
                    theSerialPortA.StopBits = StopBits.One;
                else if (text == "1.5")
                    theSerialPortA.StopBits = StopBits.OnePointFive;
                else if (text == "2")
                    theSerialPortA.StopBits = StopBits.Two;


                theSerialPortA.DataBits = Convert.ToInt32((cbDataBitsA.Items[cbDataBitsA.SelectedIndex]).ToString());
                theSerialPortA.Open();
                bOpenPortA.Enabled = false;
                bClosePortA.Enabled = true;
            }
            catch (Exception)
            {
                MessageBox.Show("Öffnen des seriellen Ports A fehlgeschlagen", "Sorry no Bonus, insert coin to continue the game");
            }
            

            
            //theSerialPort.DtrEnable = true;
            //theSerialPort.RtsEnable = true;

        }

        private void bOpenPortB_Click(object sender, EventArgs e)
        {
            try
            {

                theSerialPortB.PortName = cbSerialPortB.Items[cbSerialPortB.SelectedIndex].ToString();
                theSerialPortB.BaudRate = Convert.ToInt32((cbBaudB.Items[cbBaudB.SelectedIndex]).ToString());
                string text = cbParityB.Items[cbParityB.SelectedIndex].ToString();
                if (text == "Even")
                    theSerialPortB.Parity = Parity.Even;
                else if (text == "Mark")
                    theSerialPortB.Parity = Parity.Mark;
                else if (text == "None")
                    theSerialPortB.Parity = Parity.None;
                else if (text == "Odd")
                    theSerialPortB.Parity = Parity.Odd;
                else if (text == "Space")
                    theSerialPortB.Parity = Parity.Space;

                text = cbStopB.Items[cbStopB.SelectedIndex].ToString();
                if (text == "0")
                    theSerialPortB.StopBits = StopBits.None;
                else if (text == "1")
                    theSerialPortB.StopBits = StopBits.One;
                else if (text == "1.5")
                    theSerialPortB.StopBits = StopBits.OnePointFive;
                else if (text == "2")
                    theSerialPortB.StopBits = StopBits.Two;

                theSerialPortB.DataBits = Convert.ToInt32((cbDataBitsB.Items[cbDataBitsB.SelectedIndex]).ToString());
                theSerialPortB.Open();
                bOpenPortB.Enabled = false;
                bClosePortB.Enabled = true;
            }
            catch (Exception)
            {
                MessageBox.Show("Öffnen des seriellen Ports B fehlgeschlagen", "Sorry no Bonus, insert coin to continue the game");
            }
        }

        private void bClosePortA_Click(object sender, EventArgs e)
        {
            theSerialPortA.Close();
            bOpenPortA.Enabled = true;
            bClosePortA.Enabled = false;
        }

        private void bClosePortB_Click(object sender, EventArgs e)
        {
            theSerialPortB.Close();
            bOpenPortB.Enabled = true;
            bClosePortB.Enabled = false;
        }

        private void bDTRAOn_Click(object sender, EventArgs e)
        {
            theSerialPortA.DtrEnable = true;
        }

        private void bDTRAOff_Click(object sender, EventArgs e)
        {
            theSerialPortA.DtrEnable = false;
        }

        private void bRTSAOn_Click(object sender, EventArgs e)
        {
            theSerialPortA.RtsEnable = true;
        }

        private void bRTSAOff_Click(object sender, EventArgs e)
        {
            theSerialPortA.RtsEnable = false;
        }

        private void bDTRBOn_Click(object sender, EventArgs e)
        {
            theSerialPortB.DtrEnable = true;
        }

        private void bDTRBOff_Click(object sender, EventArgs e)
        {
            theSerialPortB.DtrEnable = false;
        }

        private void bRTSBOn_Click(object sender, EventArgs e)
        {
            theSerialPortB.RtsEnable = true;
        }

        private void bRTSBOff_Click(object sender, EventArgs e)
        {
            theSerialPortB.RtsEnable = false;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (theSerialPortA.IsOpen)
                theSerialPortA.Close();
            if (theSerialPortB.IsOpen)
                theSerialPortB.Close();

        }
    }
}
